diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/traffic-control/model/cobalt-queue-disc.cc ns-3.34/src/traffic-control/model/cobalt-queue-disc.cc
--- ns-3.33/src/traffic-control/model/cobalt-queue-disc.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/traffic-control/model/cobalt-queue-disc.cc	2021-07-14 10:31:07.000000000 -0700
@@ -72,7 +72,7 @@
     .AddAttribute ("Pdrop",
                    "Marking Probability",
                    DoubleValue (0),
-                   MakeDoubleAccessor (&CobaltQueueDisc::m_Pdrop),
+                   MakeDoubleAccessor (&CobaltQueueDisc::m_pDrop),
                    MakeDoubleChecker<double> ())
     .AddAttribute ("Increment",
                    "Pdrop increment value",
@@ -84,6 +84,21 @@
                    DoubleValue (1. / 4096),
                    MakeDoubleAccessor (&CobaltQueueDisc::m_decrement),
                    MakeDoubleChecker<double> ())
+    .AddAttribute ("CeThreshold",
+                   "The CoDel CE threshold for marking packets",
+                   TimeValue (Time::Max ()),
+                   MakeTimeAccessor (&CobaltQueueDisc::m_ceThreshold),
+                   MakeTimeChecker ())
+    .AddAttribute ("UseL4s",
+                   "True to use L4S (only ECT1 packets are marked at CE threshold)",
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&CobaltQueueDisc::m_useL4s),
+                   MakeBooleanChecker ())
+    .AddAttribute ("BlueThreshold",
+                   "The Threshold after which Blue is enabled",
+                   TimeValue (MilliSeconds (400)),
+                   MakeTimeAccessor (&CobaltQueueDisc::m_blueThreshold),
+                   MakeTimeChecker ())
     .AddTraceSource ("Count",
                      "Cobalt count",
                      MakeTraceSourceAccessor (&CobaltQueueDisc::m_count),
@@ -144,9 +159,9 @@
   m_uv = CreateObject<UniformRandomVariable> ();
 }
 
-double CobaltQueueDisc::GetPdrop ()
+double CobaltQueueDisc::GetPdrop () const
 {
-  return m_Pdrop;
+  return m_pDrop;
 }
 
 CobaltQueueDisc::~CobaltQueueDisc ()
@@ -189,25 +204,25 @@
 }
 
 int64_t
-CobaltQueueDisc::Time2CoDel (Time t)
+CobaltQueueDisc::Time2CoDel (Time t) const
 {
   return (t.GetNanoSeconds ());
 }
 
 Time
-CobaltQueueDisc::GetTarget (void)
+CobaltQueueDisc::GetTarget (void) const
 {
   return m_target;
 }
 
 Time
-CobaltQueueDisc::GetInterval (void)
+CobaltQueueDisc::GetInterval (void) const
 {
   return m_interval;
 }
 
 int64_t
-CobaltQueueDisc::GetDropNext (void)
+CobaltQueueDisc::GetDropNext (void) const
 {
   return m_dropNext;
 }
@@ -393,7 +408,7 @@
   if (CoDelTimeAfter ((now - m_lastUpdateTimeBlue), Time2CoDel (m_target)))
     {
       NS_LOG_LOGIC ("inside IF block");
-      m_Pdrop = min (m_Pdrop + m_increment, (double)1.0);
+      m_pDrop = min (m_pDrop + m_increment, (double)1.0);
       m_lastUpdateTimeBlue = now;
     }
   m_dropping = true;
@@ -408,9 +423,9 @@
 void CobaltQueueDisc::CobaltQueueEmpty (int64_t now)
 {
   NS_LOG_FUNCTION (this);
-  if (m_Pdrop && CoDelTimeAfter ((now - m_lastUpdateTimeBlue), Time2CoDel (m_target)))
+  if (m_pDrop && CoDelTimeAfter ((now - m_lastUpdateTimeBlue), Time2CoDel (m_target)))
     {
-      m_Pdrop = max (m_Pdrop - m_decrement, (double)0.0);
+      m_pDrop = max (m_pDrop - m_decrement, (double)0.0);
       m_lastUpdateTimeBlue = now;
     }
   m_dropping = false;
@@ -436,6 +451,31 @@
   int64_t schedule = now - m_dropNext;
   bool over_target = CoDelTimeAfter (sojournTime, Time2CoDel (m_target));
   bool next_due = m_count && schedule >= 0;
+  bool isMarked = false;
+
+  // If L4S mode is enabled then check if the packet is ECT1 or CE and
+  // if sojourn time is greater than CE threshold then the packet is marked.
+  // If packet is marked succesfully then the CoDel steps can be skipped.
+  if (item && m_useL4s)
+    {
+      uint8_t tosByte = 0;
+      if (item->GetUint8Value (QueueItem::IP_DSFIELD, tosByte) && (((tosByte & 0x3) == 1) || (tosByte & 0x3) == 3))
+        {
+          if ((tosByte & 0x3) == 1)
+            {
+              NS_LOG_DEBUG ("ECT1 packet " << static_cast<uint16_t> (tosByte & 0x3));
+            }
+          else
+            {
+              NS_LOG_DEBUG ("CE packet " << static_cast<uint16_t> (tosByte & 0x3));
+            }
+          if (CoDelTimeAfter (sojournTime, Time2CoDel (m_ceThreshold)) && Mark (item, CE_THRESHOLD_EXCEEDED_MARK))
+            {
+              NS_LOG_LOGIC ("Marking due to CeThreshold " << m_ceThreshold.GetSeconds ());
+            }
+          return false;
+        }
+    }
 
   if (over_target)
     {
@@ -458,7 +498,8 @@
     {
       /* Check for marking possibility only if BLUE decides NOT to drop. */
       /* Check if router and packet, both have ECN enabled. Only if this is true, mark the packet. */
-      drop = !(m_useEcn && Mark (item, FORCED_MARK));
+      isMarked = (m_useEcn && Mark (item, FORCED_MARK));
+      drop = !isMarked;
 
       m_count = max (m_count, m_count + 1);
 
@@ -477,11 +518,27 @@
           next_due = m_count && schedule >= 0;
         }
     }
+
+  // If CE threshold is enabled then isMarked flag is used to determine whether
+  // packet is marked and if the packet is marked then a second attempt at marking should be suppressed.
+  // If UseL4S attribute is enabled then ECT0 packets should not be marked.
+  if (!isMarked && !m_useL4s && m_useEcn && CoDelTimeAfter (sojournTime, Time2CoDel (m_ceThreshold)) && Mark (item, CE_THRESHOLD_EXCEEDED_MARK))
+    {
+      NS_LOG_LOGIC ("Marking due to CeThreshold " << m_ceThreshold.GetSeconds ());
+    }
+
+  // Enable Blue Enhancement if sojourn time is greater than blueThreshold and its been m_target time until the last time blue was updated
+  if (CoDelTimeAfter (sojournTime, Time2CoDel (m_blueThreshold)) && CoDelTimeAfter ((now - m_lastUpdateTimeBlue), Time2CoDel (m_target)))
+    {
+      m_pDrop = min (m_pDrop + m_increment, (double)1.0);
+      m_lastUpdateTimeBlue = now;
+    }
+
   /* Simple BLUE implementation. Lack of ECN is deliberate. */
-  if (m_Pdrop)
+  if (m_pDrop)
     {
       double u = m_uv->GetValue ();
-      drop = drop | (u < m_Pdrop);
+      drop = drop | (u < m_pDrop);
     }
 
   /* Overload the drop_next field as an activity timeout */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/traffic-control/model/cobalt-queue-disc.h ns-3.34/src/traffic-control/model/cobalt-queue-disc.h
--- ns-3.33/src/traffic-control/model/cobalt-queue-disc.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/traffic-control/model/cobalt-queue-disc.h	2021-07-14 10:31:07.000000000 -0700
@@ -84,32 +84,33 @@
    *
    * \returns The target queue delay
    */
-  Time GetTarget (void);
+  Time GetTarget (void) const;
 
   /**
    * \brief Get the interval
    *
    * \returns The interval
    */
-  Time GetInterval (void);
+  Time GetInterval (void) const;
 
   /**
    * \brief Get the time for next packet drop while in the dropping state
    *
-   * \returns The time for next packet drop
+   * \returns The time (in microseconds) for next packet drop
    */
-  int64_t GetDropNext (void);
+  int64_t GetDropNext (void) const;
 
   static constexpr const char* TARGET_EXCEEDED_DROP = "Target exceeded drop";  //!< Sojourn time above target
   static constexpr const char* OVERLIMIT_DROP = "Overlimit drop";  //!< Overlimit dropped packet
   static constexpr const char* FORCED_MARK = "forcedMark";  //!< forced marks by Codel on ECN-enabled
+  static constexpr const char* CE_THRESHOLD_EXCEEDED_MARK = "CE threshold exceeded mark";  //!< Sojourn time above CE threshold
 
   /**
    * \brief Get the drop probability of Blue
    *
    * \returns The current value of Blue's drop probability
    */
-  double GetPdrop ();
+  double GetPdrop () const;
 
   /**
    * Assign a fixed random variable stream number to the random variables
@@ -127,7 +128,7 @@
    * @param t the input Time Object
    * @return the unsigned 32-bit integer representation
    */
-  int64_t Time2CoDel (Time t);
+  int64_t Time2CoDel (Time t) const;
 
 protected:
   /**
@@ -197,17 +198,21 @@
 
   /**
    * Called when the queue becomes full to alter the drop probabilities of Blue
+   * \param now time in CoDel time units (microseconds)
    */
   void CobaltQueueFull (int64_t now);
 
   /**
    * Called when the queue becomes empty to alter the drop probabilities of Blue
+   * \param now time in CoDel time units (microseconds)
    */
   void CobaltQueueEmpty (int64_t now);
 
   /**
    * Called to decide whether the current packet should be dropped based on decisions taken by Blue and Codel working parallely
    * Returns true if the packet should be dropped, false otherwise
+   * \param item current packet
+   * \param now time in CoDel time units (microseconds)
    */
   bool CobaltShouldDrop (Ptr<QueueDiscItem> item, int64_t now);
 
@@ -224,9 +229,12 @@
   uint32_t m_recInvSqrtCache[REC_INV_SQRT_CACHE] = {0};   //!< Cache to maintain some initial values of InvSqrt
 
   // Supplied by user
-  Time m_interval;                        //!< 100 ms sliding minimum time window width
-  Time m_target;                          //!< 5 ms target queue delay
+  Time m_interval;                        //!< sliding minimum time window width
+  Time m_target;                          //!< target queue delay
   bool m_useEcn;                          //!< True if ECN is used (packets are marked instead of being dropped)
+  Time m_ceThreshold;                     //!< Threshold above which to CE mark
+  bool m_useL4s;                          //!< True if L4S is used (ECT1 packets are marked at CE threshold)
+  Time m_blueThreshold;                   //!< Threshold to enable blue enhancement
 
   // Blue parameters
   // Maintained by Cobalt
@@ -236,7 +244,7 @@
   // Supplied by user
   double m_increment;                     //!< increment value for marking probability
   double m_decrement;                     //!< decrement value for marking probability
-  double m_Pdrop;                         //!< Drop Probability
+  double m_pDrop;                         //!< Drop Probability
 
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/traffic-control/model/fq-cobalt-queue-disc.cc ns-3.34/src/traffic-control/model/fq-cobalt-queue-disc.cc
--- ns-3.33/src/traffic-control/model/fq-cobalt-queue-disc.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/traffic-control/model/fq-cobalt-queue-disc.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,531 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2016 Universita' degli Studi di Napoli Federico II
+ * Copyright (c) 2020 NITK Surathkal (adapted for COBALT)
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Pasquale Imputato <p.imputato@gmail.com>
+ *          Stefano Avallone <stefano.avallone@unina.it>
+ * Modified by: Bhaskar Kataria <bhaskar.k7920@gmail.com> (for COBALT)
+ *          Tom Henderson <tomhend@u.washington.edu>
+ *          Mohit P. Tahiliani <tahiliani@nitk.edu.in>
+ *          Vivek Jain <jain.vivek.anand@gmail.com>
+ *          Ankit Deepak <adadeepak8@gmail.com>
+ */
+
+#include "ns3/log.h"
+#include "ns3/string.h"
+#include "ns3/queue.h"
+#include "fq-cobalt-queue-disc.h"
+#include "cobalt-queue-disc.h"
+#include "ns3/net-device-queue-interface.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("FqCobaltQueueDisc");
+
+NS_OBJECT_ENSURE_REGISTERED (FqCobaltFlow);
+
+TypeId FqCobaltFlow::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::FqCobaltFlow")
+    .SetParent<QueueDiscClass> ()
+    .SetGroupName ("TrafficControl")
+    .AddConstructor<FqCobaltFlow> ()
+  ;
+  return tid;
+}
+
+FqCobaltFlow::FqCobaltFlow ()
+  : m_deficit (0),
+    m_status (INACTIVE),
+    m_index (0)
+{
+  NS_LOG_FUNCTION (this);
+}
+
+FqCobaltFlow::~FqCobaltFlow ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+void
+FqCobaltFlow::SetDeficit (uint32_t deficit)
+{
+  NS_LOG_FUNCTION (this << deficit);
+  m_deficit = deficit;
+}
+
+int32_t
+FqCobaltFlow::GetDeficit (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return m_deficit;
+}
+
+void
+FqCobaltFlow::IncreaseDeficit (int32_t deficit)
+{
+  NS_LOG_FUNCTION (this << deficit);
+  m_deficit += deficit;
+}
+
+void
+FqCobaltFlow::SetStatus (FlowStatus status)
+{
+  NS_LOG_FUNCTION (this);
+  m_status = status;
+}
+
+FqCobaltFlow::FlowStatus
+FqCobaltFlow::GetStatus (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return m_status;
+}
+
+void
+FqCobaltFlow::SetIndex (uint32_t index)
+{
+  NS_LOG_FUNCTION (this);
+  m_index = index;
+}
+
+uint32_t
+FqCobaltFlow::GetIndex (void) const
+{
+  return m_index;
+}
+
+
+NS_OBJECT_ENSURE_REGISTERED (FqCobaltQueueDisc);
+
+TypeId FqCobaltQueueDisc::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::FqCobaltQueueDisc")
+    .SetParent<QueueDisc> ()
+    .SetGroupName ("TrafficControl")
+    .AddConstructor<FqCobaltQueueDisc> ()
+    .AddAttribute ("UseEcn",
+                   "True to use ECN (packets are marked instead of being dropped)",
+                   BooleanValue (true),
+                   MakeBooleanAccessor (&FqCobaltQueueDisc::m_useEcn),
+                   MakeBooleanChecker ())
+    .AddAttribute ("Interval",
+                   "The CoDel algorithm interval for each FqCobalt queue",
+                   StringValue ("100ms"),
+                   MakeStringAccessor (&FqCobaltQueueDisc::m_interval),
+                   MakeStringChecker ())
+    .AddAttribute ("Target",
+                   "The CoDel algorithm target queue delay for each FqCobalt queue",
+                   StringValue ("5ms"),
+                   MakeStringAccessor (&FqCobaltQueueDisc::m_target),
+                   MakeStringChecker ())
+    .AddAttribute ("MaxSize",
+                   "The maximum number of packets accepted by this queue disc",
+                   QueueSizeValue (QueueSize ("10240p")),
+                   MakeQueueSizeAccessor (&QueueDisc::SetMaxSize,
+                                          &QueueDisc::GetMaxSize),
+                   MakeQueueSizeChecker ())
+    .AddAttribute ("Flows",
+                   "The number of queues into which the incoming packets are classified",
+                   UintegerValue (1024),
+                   MakeUintegerAccessor (&FqCobaltQueueDisc::m_flows),
+                   MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("DropBatchSize",
+                   "The maximum number of packets dropped from the fat flow",
+                   UintegerValue (64),
+                   MakeUintegerAccessor (&FqCobaltQueueDisc::m_dropBatchSize),
+                   MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("Perturbation",
+                   "The salt used as an additional input to the hash function used to classify packets",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&FqCobaltQueueDisc::m_perturbation),
+                   MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("CeThreshold",
+                   "The FqCobalt CE threshold for marking packets",
+                   TimeValue (Time::Max ()),
+                   MakeTimeAccessor (&FqCobaltQueueDisc::m_ceThreshold),
+                   MakeTimeChecker ())
+    .AddAttribute ("EnableSetAssociativeHash",
+                   "Enable/Disable Set Associative Hash",
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&FqCobaltQueueDisc::m_enableSetAssociativeHash),
+                   MakeBooleanChecker ())
+    .AddAttribute ("SetWays",
+                   "The size of a set of queues (used by set associative hash)",
+                   UintegerValue (8),
+                   MakeUintegerAccessor (&FqCobaltQueueDisc::m_setWays),
+                   MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("UseL4s",
+                   "True to use L4S (only ECT1 packets are marked at CE threshold)",
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&FqCobaltQueueDisc::m_useL4s),
+                   MakeBooleanChecker ())
+    .AddAttribute ("Pdrop",
+                   "Marking Probability",
+                   DoubleValue (0),
+                   MakeDoubleAccessor (&FqCobaltQueueDisc::m_Pdrop),
+                   MakeDoubleChecker<double> ())
+    .AddAttribute ("Increment",
+                   "Pdrop increment value",
+                   DoubleValue (1. / 256),
+                   MakeDoubleAccessor (&FqCobaltQueueDisc::m_increment),
+                   MakeDoubleChecker<double> ())
+    .AddAttribute ("Decrement",
+                   "Pdrop decrement Value",
+                   DoubleValue (1. / 4096),
+                   MakeDoubleAccessor (&FqCobaltQueueDisc::m_decrement),
+                   MakeDoubleChecker<double> ())
+    .AddAttribute ("BlueThreshold",
+                   "The Threshold after which Blue is enabled",
+                   TimeValue (MilliSeconds (400)),
+                   MakeTimeAccessor (&FqCobaltQueueDisc::m_blueThreshold),
+                   MakeTimeChecker ())
+  ;
+  return tid;
+}
+
+FqCobaltQueueDisc::FqCobaltQueueDisc ()
+  : QueueDisc (QueueDiscSizePolicy::MULTIPLE_QUEUES, QueueSizeUnit::PACKETS),
+    m_quantum (0)
+{
+  NS_LOG_FUNCTION (this);
+}
+
+FqCobaltQueueDisc::~FqCobaltQueueDisc ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+void
+FqCobaltQueueDisc::SetQuantum (uint32_t quantum)
+{
+  NS_LOG_FUNCTION (this << quantum);
+  m_quantum = quantum;
+}
+
+uint32_t
+FqCobaltQueueDisc::GetQuantum (void) const
+{
+  return m_quantum;
+}
+
+uint32_t
+FqCobaltQueueDisc::SetAssociativeHash (uint32_t flowHash)
+{
+  NS_LOG_FUNCTION (this << flowHash);
+
+  uint32_t h = (flowHash % m_flows);
+  uint32_t innerHash = h % m_setWays;
+  uint32_t outerHash = h - innerHash;
+
+  for (uint32_t i = outerHash; i < outerHash + m_setWays; i++)
+    {
+      auto it = m_flowsIndices.find (i);
+
+      if (it == m_flowsIndices.end ()
+          || (m_tags.find (i) != m_tags.end () && m_tags[i] == flowHash)
+          || StaticCast<FqCobaltFlow> (GetQueueDiscClass (it->second))->GetStatus () == FqCobaltFlow::INACTIVE)
+        {
+          // this queue has not been created yet or is associated with this flow
+          // or is inactive, hence we can use it
+          m_tags[i] = flowHash;
+          return i;
+        }
+    }
+
+  // all the queues of the set are used. Use the first queue of the set
+  m_tags[outerHash] = flowHash;
+  return outerHash;
+}
+
+bool
+FqCobaltQueueDisc::DoEnqueue (Ptr<QueueDiscItem> item)
+{
+  NS_LOG_FUNCTION (this << item);
+
+  uint32_t flowHash, h;
+
+  if (GetNPacketFilters () == 0)
+    {
+      flowHash = item->Hash (m_perturbation);
+    }
+  else
+    {
+      int32_t ret = Classify (item);
+
+      if (ret != PacketFilter::PF_NO_MATCH)
+        {
+          flowHash = static_cast<uint32_t> (ret);
+        }
+      else
+        {
+          NS_LOG_ERROR ("No filter has been able to classify this packet, drop it.");
+          DropBeforeEnqueue (item, UNCLASSIFIED_DROP);
+          return false;
+        }
+    }
+
+  if (m_enableSetAssociativeHash)
+    {
+      h = SetAssociativeHash (flowHash);
+    }
+  else
+    {
+      h = flowHash % m_flows;
+    }
+
+  Ptr<FqCobaltFlow> flow;
+  if (m_flowsIndices.find (h) == m_flowsIndices.end ())
+    {
+      NS_LOG_DEBUG ("Creating a new flow queue with index " << h);
+      flow = m_flowFactory.Create<FqCobaltFlow> ();
+      Ptr<QueueDisc> qd = m_queueDiscFactory.Create<QueueDisc> ();
+      // If Cobalt, Set values of CobaltQueueDisc to match this QueueDisc
+      Ptr<CobaltQueueDisc> cobalt = qd->GetObject<CobaltQueueDisc> ();
+      if (cobalt)
+        {
+          cobalt->SetAttribute ("UseEcn", BooleanValue (m_useEcn));
+          cobalt->SetAttribute ("CeThreshold", TimeValue (m_ceThreshold));
+          cobalt->SetAttribute ("UseL4s", BooleanValue (m_useL4s));
+          cobalt->SetAttribute ("BlueThreshold", TimeValue (m_blueThreshold));
+        }
+      qd->Initialize ();
+      flow->SetQueueDisc (qd);
+      flow->SetIndex (h);
+      AddQueueDiscClass (flow);
+
+      m_flowsIndices[h] = GetNQueueDiscClasses () - 1;
+    }
+  else
+    {
+      flow = StaticCast<FqCobaltFlow> (GetQueueDiscClass (m_flowsIndices[h]));
+    }
+
+  if (flow->GetStatus () == FqCobaltFlow::INACTIVE)
+    {
+      flow->SetStatus (FqCobaltFlow::NEW_FLOW);
+      flow->SetDeficit (m_quantum);
+      m_newFlows.push_back (flow);
+    }
+
+  flow->GetQueueDisc ()->Enqueue (item);
+
+  NS_LOG_DEBUG ("Packet enqueued into flow " << h << "; flow index " << m_flowsIndices[h]);
+
+  if (GetCurrentSize () > GetMaxSize ())
+    {
+      NS_LOG_DEBUG ("Overload; enter FqCobaltDrop ()");
+      FqCobaltDrop ();
+    }
+
+  return true;
+}
+
+Ptr<QueueDiscItem>
+FqCobaltQueueDisc::DoDequeue (void)
+{
+  NS_LOG_FUNCTION (this);
+
+  Ptr<FqCobaltFlow> flow;
+  Ptr<QueueDiscItem> item;
+
+  do
+    {
+      bool found = false;
+
+      while (!found && !m_newFlows.empty ())
+        {
+          flow = m_newFlows.front ();
+
+          if (flow->GetDeficit () <= 0)
+            {
+              NS_LOG_DEBUG ("Increase deficit for new flow index " << flow->GetIndex ());
+              flow->IncreaseDeficit (m_quantum);
+              flow->SetStatus (FqCobaltFlow::OLD_FLOW);
+              m_oldFlows.push_back (flow);
+              m_newFlows.pop_front ();
+            }
+          else
+            {
+              NS_LOG_DEBUG ("Found a new flow " << flow->GetIndex () << " with positive deficit");
+              found = true;
+            }
+        }
+
+      while (!found && !m_oldFlows.empty ())
+        {
+          flow = m_oldFlows.front ();
+
+          if (flow->GetDeficit () <= 0)
+            {
+              NS_LOG_DEBUG ("Increase deficit for old flow index " << flow->GetIndex ());
+              flow->IncreaseDeficit (m_quantum);
+              m_oldFlows.push_back (flow);
+              m_oldFlows.pop_front ();
+            }
+          else
+            {
+              NS_LOG_DEBUG ("Found an old flow " << flow->GetIndex () << " with positive deficit");
+              found = true;
+            }
+        }
+
+      if (!found)
+        {
+          NS_LOG_DEBUG ("No flow found to dequeue a packet");
+          return 0;
+        }
+
+      item = flow->GetQueueDisc ()->Dequeue ();
+
+      if (!item)
+        {
+          NS_LOG_DEBUG ("Could not get a packet from the selected flow queue");
+          if (!m_newFlows.empty ())
+            {
+              flow->SetStatus (FqCobaltFlow::OLD_FLOW);
+              m_oldFlows.push_back (flow);
+              m_newFlows.pop_front ();
+            }
+          else
+            {
+              flow->SetStatus (FqCobaltFlow::INACTIVE);
+              m_oldFlows.pop_front ();
+            }
+        }
+      else
+        {
+          NS_LOG_DEBUG ("Dequeued packet " << item->GetPacket ());
+        }
+    }
+  while (item == 0);
+
+  flow->IncreaseDeficit (item->GetSize () * -1);
+
+  return item;
+}
+
+bool
+FqCobaltQueueDisc::CheckConfig (void)
+{
+  NS_LOG_FUNCTION (this);
+  if (GetNQueueDiscClasses () > 0)
+    {
+      NS_LOG_ERROR ("FqCobaltQueueDisc cannot have classes");
+      return false;
+    }
+
+  if (GetNInternalQueues () > 0)
+    {
+      NS_LOG_ERROR ("FqCobaltQueueDisc cannot have internal queues");
+      return false;
+    }
+  // we are at initialization time. If the user has not set a quantum value,
+  // set the quantum to the MTU of the device (if any)
+  if (!m_quantum)
+    {
+      Ptr<NetDeviceQueueInterface> ndqi = GetNetDeviceQueueInterface ();
+      Ptr<NetDevice> dev;
+      // if the NetDeviceQueueInterface object is aggregated to a
+      // NetDevice, get the MTU of such NetDevice
+      if (ndqi && (dev = ndqi->GetObject<NetDevice> ()))
+        {
+          m_quantum = dev->GetMtu ();
+          NS_LOG_DEBUG ("Setting the quantum to the MTU of the device: " << m_quantum);
+        }
+
+      if (!m_quantum)
+        {
+          NS_LOG_ERROR ("The quantum parameter cannot be null");
+          return false;
+        }
+    }
+
+  if (m_enableSetAssociativeHash && (m_flows % m_setWays != 0))
+    {
+      NS_LOG_ERROR ("The number of queues must be an integer multiple of the size "
+                    "of the set of queues used by set associative hash");
+      return false;
+    }
+
+  // If UseL4S attribute is enabled then CE threshold must be set.
+  if (m_useL4s)
+    {
+      NS_ABORT_MSG_IF (m_ceThreshold == Time::Max (), "CE threshold not set");
+      if (m_useEcn == false)
+        {
+          NS_LOG_WARN ("Enabling ECN as L4S mode is enabled");
+        }
+    }
+  return true;
+}
+
+void
+FqCobaltQueueDisc::InitializeParams (void)
+{
+  NS_LOG_FUNCTION (this);
+
+  m_flowFactory.SetTypeId ("ns3::FqCobaltFlow");
+
+  m_queueDiscFactory.SetTypeId ("ns3::CobaltQueueDisc");
+  m_queueDiscFactory.Set ("MaxSize", QueueSizeValue (GetMaxSize ()));
+  m_queueDiscFactory.Set ("Interval", StringValue (m_interval));
+  m_queueDiscFactory.Set ("Target", StringValue (m_target));
+  m_queueDiscFactory.Set ("Pdrop", DoubleValue (m_Pdrop));
+  m_queueDiscFactory.Set ("Increment", DoubleValue (m_increment));
+  m_queueDiscFactory.Set ("Decrement", DoubleValue (m_decrement));
+}
+
+uint32_t
+FqCobaltQueueDisc::FqCobaltDrop (void)
+{
+  NS_LOG_FUNCTION (this);
+
+  uint32_t maxBacklog = 0, index = 0;
+  Ptr<QueueDisc> qd;
+
+  /* Queue is full! Find the fat flow and drop packet(s) from it */
+  for (uint32_t i = 0; i < GetNQueueDiscClasses (); i++)
+    {
+      qd = GetQueueDiscClass (i)->GetQueueDisc ();
+      uint32_t bytes = qd->GetNBytes ();
+      if (bytes > maxBacklog)
+        {
+          maxBacklog = bytes;
+          index = i;
+        }
+    }
+
+  /* Our goal is to drop half of this fat flow backlog */
+  uint32_t len = 0, count = 0, threshold = maxBacklog >> 1;
+  qd = GetQueueDiscClass (index)->GetQueueDisc ();
+  Ptr<QueueDiscItem> item;
+
+  do
+    {
+      NS_LOG_DEBUG ("Drop packet (overflow); count: " << count << " len: " << len << " threshold: " << threshold);
+      item = qd->GetInternalQueue (0)->Dequeue ();
+      DropAfterDequeue (item, OVERLIMIT_DROP);
+      len += item->GetSize ();
+    }
+  while (++count < m_dropBatchSize && len < threshold);
+
+  return index;
+}
+
+} // namespace ns3
+
